
Thank you for visiting this repository!
This repository contains the implementation of our ICLR-25 paper **LLM-based Typed Hyperresolution for Commonsense Reasoning with Knowledge Bases**.

In order to use the code, please follow these steps:

## 0- Install requirements
~~~
pip install -r requirements.txt
~~~

## 1- Download the required [datasets](https://drive.google.com/drive/folders/1RYhvoJ1rJCXRRsifE6CtZmajJ__O3zEH?usp=sharing) and place them in this directory.

## 2- Running Experiments for Deductive Reasoning and Geographical QA
You can run our model on these datasets using commands like the following:
~~~
python -m run --data/ --dataset_name onto --scoring_method typed resolution --experiment_name test --llm_name gpt --retrieve_method st --exact_match False
~~~

Here, "dataset_name" can take values "geo" and "onto".

You can also try our baselines by switching the "scoring_method" argument to "zero shot CoT", "few shot CoT RAG", "zero shot CoT RAG", and "few shot CoT RAG".

For running our model on Recipe-MPR, please run the notebook "recipe-mpr.ipynb" in the "recipe-mpr" folder.


Thank you for your attention!
